// -------------------------------------------------------------------------------------
// threadStdio.h
// Thread safe printf(), sprintf(), etc.
// -------------------------------------------------------------------------------------
#import <stdio.h>

// -------------------------------------------------------------------------------------
void thread_initStdio();

// -------------------------------------------------------------------------------------
#define	vprintf		thread_vprintf
#define	printf		thread_printf
#define	vfprintf	thread_vfprintf
#define	fprintf		thread_fprintf
#define	vsprintf	thread_vsprintf
#define	sprintf		thread_sprintf
int thread_vprintf(const char *fmt, va_list arg);
int thread_printf(const char *fmt, ...);
int thread_vfprintf(register FILE *fhnd, const char *fmt, va_list arg);
int thread_fprintf(register FILE *iop, const char *fmt, ...);
int thread_vsprintf(char *str, const char *fmt, va_list arg);
int thread_sprintf(char *str, const char *fmt, ...);

// -------------------------------------------------------------------------------------
#define	vfscanf		thread_vfscanf
#define	scanf		thread_scanf
#define	sscanf		thread_sscanf
#define	fscanf		thread_fscanf
int thread_vfscanf(FILE *fhnd, const char *fmt, va_list arg);
int thread_scanf(const char *fmt, ...);
int thread_fscanf(FILE *iop, const char *fmt, ...);
int thread_sscanf(register const char *str, const char *fmt, ...);

